<template lang="pug">
  .root(
    :class="classes"
    :data-disabled="disabled"
  )
    input.inner(
      :type="type"
      :value="currentValue"
      :disabled="disabled"
      :readonly="readonly"
      :placeholder="placeholder"
      :data-size="size"
      @input="handleInput"
      @focus="handleFocus"
      @blur="handleBlur"
      @change="handleChange"
      
    )
    //- span.icon()
</template>

<script>
export default {
  name: 'TextInput',
  data() {
    return {
      currentValue: this.value === undefined || this.value === null ? '' : this.value
    }
  },
  props: {
    type: {
      type: String,
      default: () => 'text'
    },
    value: String,
    classes: {
      type: Array,
      default: () => []
    },
    disabled: {
      type: Boolean,
      default: false
    },
    readonly: {
      type: Boolean,
      default: false
    },
    placeholder: String,
    size: String
  },
  watch: {
    value(val, oldValue) {
      this.setCurrentValue(val)
    }
  },
  methods: {
    handleInput(event) {
      const value = event.target.value
      this.setCurrentValue(value)
      this.$emit('input', value)
    },
    setCurrentValue(value) {
      this.currentValue = value
    },
    handleFocus(event) {
      this.$emit('focus', event)
    },
    handleBlur(event) {
      this.$emit('blur', event)
    },
    handleChange(event) {
      this.$emit('change', event)
    }
  }
}
</script>

<style lang="stylus" scoped>
.root
  // font-size: $fz-base_small
  font-size: 13px
  .inner
    -webkit-appearance: none
    background-color: $c-white
    background-image: none
    border-radius: 4px
    border: 1px solid $c-border-base
    box-sizing: border-box
    color: $c-text-regular
    display: inline-block
    font-size: inherit
    height: 40px
    line-height: 40px
    outline: none
    padding: 0 15px
    transition: border-color .2s cubic-bezier(.645,.045,.355,1)
    width: 100%
    &::placeholder
      color: $c-text-placeholder
  // function
  .inner:focus
    border-color: $c-focus 
    outline: none
  &[data-disabled]
    .inner
      background-color: #f5f7fa
      border-color: #e4e7ed
      color: #c0c4cc
      cursor: not-allowed
  // size
  &[data-size="small"]
    font-size: $fz-base_small
    height: auto
    padding: 4px 8px
  &[data-size="mini"]
    font-size: $fz-ex_small
    height: auto
    padding: 2px 4px
  &:active
    opacity: 0.8
.selection
  width: 100%
</style>